// LCView.h : interface of the CLCView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_LCVIEW_H__01B518CA_F04A_11D6_8B3B_9DFBF50C2F59__INCLUDED_)
#define AFX_LCVIEW_H__01B518CA_F04A_11D6_8B3B_9DFBF50C2F59__INCLUDED_

#include "TOOLBOX.h"	// Added by ClassView
#include "Start.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CLCView : public CFormView
{
protected: // create from serialization only
	CLCView();
	DECLARE_DYNCREATE(CLCView)

public:

	//{{AFX_DATA(CLCView)
	enum { IDD = IDD_LC_FORM };
	//int		m_EFast;
	//}}AFX_DATA

// Attributes
public:
	CLCDoc* GetDocument();


// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLCView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Implementation
public:
	BOOL FastTrace;
	int OpFS;
	enum _state {off,on};
	enum kind {RLS, AND,NAND,OR,NOR,NOT,XOR,XNOR,UD,DLR,SLR,
		_1TO2LR,UL,UR,DL,DR,_DEL,EMPTY,START,END};
	int state(_state st);
	
	void sb(CDC *pDC,int x,int y,int kind);

	void Initialer();
	void Redrawer();
	void Calc();
	boolean ShowFlag;

	
	
	
	struct SCREENMEMO{
		boolean		lunched;
		kind		Gate;
		CString     SGate;
		int			Group;
		_state		inValue1;
		_state		inValue2;
		_state		outValue1;
		_state		outValue2;
		};

	SCREENMEMO screen[32][24];
	boolean ScreenMap(int x,int y,int kind);
	boolean Snaper(int x,int y,int kind);
	
	Draw2(CPaintDC pdc);
	boolean Grid();
	CWnd* m_pViewWnd;
	void Draw();
	Bk();
	inline char i2c(int i);

//	Graphic m_dGraph;
	
	CBitmap m_bmpBitmap;
	CString m_sBitmap;

	HCURSOR		lhCursor;
	CTOOLBOX	m_dToolBox;
	CStart		m_dStart;
	CMainFrame	m_dMainFrame;

	virtual ~CLCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	afx_msg void OnContextMenu(CWnd*, CPoint point);
	//{{AFX_MSG(CLCView)
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnCalc();
	afx_msg void OnPopupExit();
	afx_msg void OnDestroy();
	afx_msg void OnFileNew();
	afx_msg void OnFileSave();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
//	void ShowBitmap(/*CPaintDC *pdc,*/CWnd *pWnd);
	void ShowBitmap(int x,int y,int kind);
};

#ifndef _DEBUG  // debug version in LCView.cpp
inline CLCDoc* CLCView::GetDocument()
   { return (CLCDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LCVIEW_H__01B518CA_F04A_11D6_8B3B_9DFBF50C2F59__INCLUDED_)
